#include <set>
#include <map>
#include <list>
#include <cmath>
#include <ctime>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <cctype>
#include <cstdio>
#include <string>
#include <vector>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <sstream>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

#define Rep(i,n) for(typeof(n) i = 0; i < (n); ++i)
#define Repd(i,n) for(typeof(n) i = (n)-1; i >= 0; --i)
#define For(i,a,b) for(typeof(b) i = (a); i <= (b); ++i)
#define Ford(i,a,b) for(typeof(a) i = (a); i >= (b); --i)
#define Fit(i,v) for(typeof((v).begin()) i = (v).begin(); i != (v).end(); ++i)
#define Fitd(i,v) for(typeof((v).rbegin()) i = (v).rbegin(); i != (v).rend(); ++i)
#define mp make_pair
#define pb push_back
#define fi first
#define se second
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(), (a).end()
#define ms(a,x) memset(a, x, sizeof(a))
#define nl puts("")
#define sp printf(" ")
#define ok puts("ok")

template<class F, class T> T convert(F a, int p = -1) { stringstream ss; if (p >= 0) ss << fixed << setprecision(p); ss << a; T r; ss >> r; return r; }
template<class T> void db(T a, int p = -1) { if (p >= 0) cout << fixed << setprecision(p); cout << a << " "; }
template<class T> T gcd(T a, T b) { T r; while (b != 0) { r = a % b; a = b; b = r; } return a; }
template<class T> T lcm(T a, T b) { return a / gcd(a, b) * b; }
template<class T> T sqr(T x) { return x * x; }
template<class T> T cube(T x) { return x * x * x; }
template<class T> struct Triple { T x, y, z; Triple() {} Triple(T _x, T _y, T _z) : x(_x), y(_y), z(_z) {} };
template<class T> Triple<T> euclid(T a, T b) { if (b == 0) return Triple<T>(1, 0, a); Triple<T> r = euclid(b, a % b); return Triple<T>(r.y, r.x - a / b * r.y, r.z); }
template<class T> int getbit(T s, int i) { return (s >> i) & 1; }
template<class T> T onbit(T s, int i) { return s | (T(1) << i); }
template<class T> T offbit(T s, int i) { return s & (~(T(1) << i)); }
template<class T> int cntbit(T s) { return s == 0 ? 0 : cntbit(s >> 1) + (s & 1); }
const int bfsz = 1 << 16; char bf[bfsz + 5]; int rsz = 0;int ptr = 0;
char gc() { if (rsz <= 0) { ptr = 0; rsz = fread(bf, 1, bfsz, stdin); if (rsz <= 0) return EOF; } --rsz; return bf[ptr++]; }
void ga(char &c) { c = EOF; while (!isalpha(c)) c = gc(); }
int gs(char s[]) { int l = 0; char c = gc(); while (isspace(c)) c = gc(); while (c != EOF && !isspace(c)) { s[l++] = c; c = gc(); } s[l] = '\0'; return l; }
template<class T> bool gi(T &v) {
	v = 0; char c = gc(); while (c != EOF && c != '-' && !isdigit(c)) c = gc(); if (c == EOF) return false; bool neg = c == '-'; if (neg) c = gc();
    while (isdigit(c)) { v = v * 10 + c - '0'; c = gc(); } if (neg) v = -v; return true;
}

const double PI = 2 * acos(0);
const string months[] = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"};
const int days[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
const int dr[] = {-1, 0, +1, 0};
const int dc[] = {0, +1, 0, -1};
const int inf = (int)1e9 + 5;
const ll linf = (ll)1e16 + 5;
const double eps = 1e-9;

#define maxn 1005

int n, a[maxn], front_smaller[maxn][maxn], back_smaller[maxn][maxn], front_bigger[maxn][maxn], back_bigger[maxn][maxn];

int main() {
//    freopen("in.txt", "r", stdin);
    
    ms(front_smaller, 0); ms(back_smaller, 0);
    ms(front_bigger, 0); ms(back_bigger, 0);
    
    gi(n); For(i, 1, n) gi(a[i]);
    
    For(i, 1, n) {
        For(x, 1, n) {
            front_smaller[i][x] = front_smaller[i - 1][x];
            front_bigger[i][x] = front_bigger[i - 1][x];
            if (a[i] < x) ++front_smaller[i][x];
            if (a[i] > x) ++front_bigger[i][x];
        }
    }
    
    Ford(i, n, 1) {
        For(x, 1, n) {
            back_smaller[i][x] = back_smaller[i + 1][x];
            back_bigger[i][x] = back_bigger[i + 1][x];
            if (a[i] < x) ++back_smaller[i][x];
            if (a[i] > x) ++back_bigger[i][x];
        }
    }
    
    int res = 0;
    For(i, 1, n) res += back_smaller[i + 1][a[i]];
    
    int original = res;
    For(i, 1, n - 1) For(j, i + 1, n) {
        int x = back_smaller[i + 1][a[i]] - back_smaller[j][a[i]];
        int y = back_bigger[i + 1][a[i]] - back_bigger[j][a[i]];
        int z = front_bigger[j - 1][a[j]] - front_bigger[i][a[j]];
        int t = front_smaller[j - 1][a[j]] - front_smaller[i][a[j]];
        int changes = original - x + y - z + t;
        if (a[i] > a[j]) --changes;
        else if (a[i] < a[j]) ++changes;
        res = min(res, changes);
    }
    
    printf("%d\n", res);
    
    return 0;
}
